src/CarRental/CarRental.Web/Areas/CarOwner/ViewModels/EditCarViewModel.cs
using CarRental.Core.Enums;
using CarRental.Core.Models;
using System.ComponentModel.DataAnnotations;

namespace CarRental.Web.Areas.CarOwner.ViewModels
{
    public class EditCarViewModel
    {
        [Key]
        public Guid CarId { get; set; }
        public string? CarName { get; set; }
        public string? LicensePlate { get; set; }
        public int? BrandModelId { get; set; }
        public BrandModel? BrandModel { get; set; }
        public int ColorId { get; set; }
        public Color? Color { get; set; }

        public int NumberOfSeats { get; set; } = 0;

        [Required(ErrorMessage = "Model Name is Required!")]
        [Range(1000, 9999, ErrorMessage = "Invalid Production Year")]
        public int ProductionYears { get; set; }

        [Required(ErrorMessage = "Transmission Type is Required!")]
        public string TransmissionType { get; set; } = null!;

        [Required(ErrorMessage = "Fuel Type is Required!")]
        public string FuelType { get; set; } = null!;
        public decimal Mileage { get; set; } = 0;
        public decimal FuelConsumption { get; set; } = 0;
        public decimal BasePrice { get; set; } = 0;

		public string? SpecificAddress { get; set; }
		public decimal Deposit { get; set; } = 0;
        public string? Description { get; set; }
        public List<string>? AdditionalFunctionsEditCar { get; set; }
        public List<string>? TermsOfUseEditCar { get; set; }

        public string? OtherTermOfUse { get; set; }
        public IFormFile? FrontImg { get; set; }
        public IFormFile? BackImg { get; set; }
        public IFormFile? LeftImg { get; set; }
        public IFormFile? RightImg { get; set; }

        public CarStatus CarStatus { get; set; }
        public int? AddressID { get; set; }
        public Address? Address { get; set; }

        public Guid UserID { get; set; }
        public Account? AppUser { get; set; }

        public Guid? CarImgId { get; set; }

        public virtual CarImage? CarImage { get; set; }
    }
}

src/CarRental/CarRental.Web/Areas/CarOwner/Controllers/CarsController.cs
using AutoMapper;
using CarRental.Core.Data;
using CarRental.Core.Models;
using CarRental.DataAccess.Repositories.Interfaces;
using CarRental.Web.Areas.CarOwner.ViewModels;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using NToastNotify;
using X.PagedList;

namespace CarRental.Web.Areas.CarOwner.Controllers
{
    [Area("CarOwner")]
    [Authorize(Roles = ListRoles.CarOwner)]
    public class CarsController : Controller
    {
        private readonly ICarRepository carRepository;
        private readonly IBrandModelRepository brandModelRepository;
        private readonly IAddressRepository addressRepository;
        private readonly IBaseRepository<Color> colorRepository;
        private readonly IBookingRepository bookingRepository;
        private readonly IMapper _mapper;
        private readonly IWebHostEnvironment webHost;
        private readonly IToastNotification _toastNotification;
        private readonly UserManager<Account> userManager;
        private readonly CarRentalContext _context;

        public CarsController(ICarRepository carRepository,
            IBrandModelRepository brandModelRepository,
            IAddressRepository addressRepository,
            IBaseRepository<Color> colorRepository,
            IBookingRepository bookingRepository,
            IMapper mapper,
            IWebHostEnvironment webHost,
            IToastNotification toastNotification,
            UserManager<Account> userManager,
            CarRentalContext context)
        {
            this.carRepository = carRepository;
            this.brandModelRepository = brandModelRepository;
            this.addressRepository = addressRepository;
            this.colorRepository = colorRepository;
            this.bookingRepository = bookingRepository;
            _mapper = mapper;
            this.webHost = webHost;
            this._toastNotification = toastNotification;
            this.userManager = userManager;
            _context = context;
        }

        [HttpGet]
        public IActionResult Create()
        {
            ViewBag.ColorId = new SelectList(colorRepository.GetAll().ToList(), "ColorId", "ColorName");
            return View();
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create(AddCarViewModel carModel)
        {
            var user = await userManager.GetUserAsync(User);
            if (user != null)
            {
                carModel.UserID = user.Id;
            }
            if (ModelState.IsValid)
            {
                Car newCar = new Car();
                newCar = _mapper.Map<Car>(carModel);

                var address = addressRepository.GetAll()
                            .FirstOrDefault(x =>
                            x.City == carModel.Address.City
                            && x.District == carModel.Address.District
                            && x.Ward == carModel.Address.Ward);


                var brandModel = brandModelRepository.GetAll()
                    .FirstOrDefault(x =>
                    x.Brand == carModel.BrandModel.Brand
                    && x.Model == carModel.BrandModel.Model);

                if (address == null || brandModel == null)
                {
                    return NotFound();
                }

                if (newCar.AdditionalFunctions != null)
                {
                    newCar.AdditionalFunctions = string.Join(",", carModel.AdditionalFunctions);

                }
                if (newCar.TermsOfUse != null)
                {
                    newCar.TermsOfUse = string.Join(",", carModel.TermsOfUse);
                }

                newCar.CarId = Guid.NewGuid();
                newCar.CarName = string.Format($"{newCar.BrandModel.Brand} {newCar.BrandModel.Model} {newCar.ProductionYears}");
                newCar.Address = address;
                newCar.BrandModel = brandModel;
                newCar.AddressID = address.AddressId;
                newCar.BrandModelId = brandModel.BrandModelId;

                CarImage CarImage = new CarImage()
                {
                    Id = Guid.NewGuid(),
                    Car = newCar,
                    CarId = newCar.CarId,
                    CertificateImg = UploadCarImage(carModel.CertificateImg),
                    InsuranceImg = UploadCarImage(carModel.InsuranceImg),
                    Registration = UploadCarImage(carModel.RegistrationImg),
                    FrontImg = UploadCarImage(carModel.FrontImg),
                    BackImg = UploadCarImage(carModel.BackImg),
                    LeftImg = UploadCarImage(carModel.LeftImg),
                    RightImg = UploadCarImage(carModel.RightImg)
                };

                newCar.CarImgId = CarImage.Id;
                newCar.CarImage = CarImage;

                newCar.SpecificAddress = carModel.SpecificAddress;

                carRepository.Add(newCar);
                await carRepository.SaveChangeAsync();

                // xoa folder tam thoi luu anh
                var tempFileFolder = Path.Combine(webHost.WebRootPath, "tempImgFile");
                if (Directory.Exists(tempFileFolder))
                {
                    Directory.Delete(tempFileFolder, true);
                }
                _toastNotification.AddSuccessToastMessage("Add new car successfully!! Please check your car");

                return RedirectToAction(nameof(ViewCarsList));
            }

            return View(carModel);
        }

        public async Task<IActionResult> ViewCarsList()
        {
            var user = await userManager.GetUserAsync(User);
            var cars = await carRepository.GetInclude(x => x.UserID == user.Id, "Address", "Color", "BrandModel", "CarImage")
                .ToListAsync();

            var ratings = _context.Cars.Include(x => x.Bookings).ThenInclude(x => x.Feedbacks).FirstOrDefault();

            if (ratings != null)
            {
                int ratingSum = (int)ratings.Bookings
                    .SelectMany(booking => booking.Feedbacks)
                    .Sum(feedback => feedback.Ratings);

                int countRatings = ratings.Bookings
                    .SelectMany(booking => booking.Feedbacks)
                    .Count();

                decimal avgRate = countRatings > 0 ? (decimal)ratingSum / countRatings : 0;

                ViewBag.TotalRatings = ratingSum;
                ViewBag.RateCount = countRatings;
                ViewBag.AvgRate = (double)avgRate;
            }
            return View(cars);
        }

        [HttpGet]
        public async Task<IActionResult> SortAndPaginateCars(string sortOrder, int pageNumber = 1, int pageSize = 3)
        {
            var currentUser = await userManager.GetUserAsync(User);
            var query = carRepository.GetInclude(x => x.UserID == currentUser.Id, "Address", "BrandModel", "CarImage");

            IEnumerable<Car> cars;

            switch (sortOrder)
            {
                case "Newest to Lastest":
                    cars = await query.OrderByDescending(x => x.CreateAt).ToListAsync();
                    break;
                case "Lastest to Newest":
                    cars = await query.OrderBy(x => x.ProductionYears).ToListAsync();
                    break;
                case "Order By Price":
                    cars = await query.OrderBy(x => x.BasePrice).ToListAsync();
                    break;
                default:
                    // Xử lý lựa chọn sắp xếp không hợp lệ ở đây
                    return BadRequest("Invalid sort option");
            }
            var totalCount = cars.Count();
            var totalPages = (int)Math.Ceiling((double)totalCount / pageSize);
            ViewBag.TotalPages = totalPages;

            var paginatedCars = cars.Skip((pageNumber - 1) * pageSize).Take(pageSize).ToList();

            return PartialView("_CarsListPartial", paginatedCars);
        }



        /*        public IActionResult List()
                {
                    var cars = carRepository.GetAll();
                    return View(cars);
                }*/

        [HttpGet]
        public IActionResult EditCar(Guid carId)
        {
            var car = carRepository
                .GetInclude(x => x.CarId == carId, "Address", "CarImage", "Color", "BrandModel")
                .FirstOrDefault();

            EditCarViewModel CarModel = _mapper.Map<EditCarViewModel>(car);
            string[] listAddtional;
            string[] listTermOfUse;
            if (car.AdditionalFunctions != null && car.AdditionalFunctions.Count() > 0)
            {
                listAddtional = car.AdditionalFunctions.Split(",");
            }
            else
            {
                listAddtional = new string[1] { "" };
            }

            if (car.TermsOfUse != null && car.TermsOfUse.Count() > 0)
            {
                listTermOfUse = car.TermsOfUse.Split(",");
            }
            else
            {
                listTermOfUse = new string[1] { "" };
            }


            CarModel.AdditionalFunctionsEditCar = new List<string>(listAddtional);
            CarModel.TermsOfUseEditCar = new List<string>(listTermOfUse);

            if (CarModel.TermsOfUseEditCar.Any(x => x.Equals("other", StringComparison.CurrentCultureIgnoreCase)))
            {
                var listOtherTermOfUse = CarModel.TermsOfUseEditCar.SkipWhile(x => x != "other").Skip(1).ToList();
                CarModel.OtherTermOfUse = string.Join(",", listOtherTermOfUse);
            }


            var ratings = _context.Cars.Include(x => x.Bookings).ThenInclude(x => x.Feedbacks).FirstOrDefault(x => x.CarId == carId);

            if (ratings != null)
            {
                int ratingSum = (int)ratings.Bookings

src/CarRental/CarRental.Web/Areas/CarOwner/Views/Cars/ViewCarsList.cshtml
@model IEnumerable<CarRental.Core.Models.Car>

@{
    ViewData["Title"] = "List";
    Layout = "~/Areas/CarOwner/Views/Shared/_Layout.cshtml";
}
<style>
    .carousel-item {
        height: 280px;
    }

        .carousel-item img {
            height: 280px !important;
        }
</style>

<section class="ftco-section bg-light">
    <div class="container">
        <div class="row">
            <div class="col-md-8">
                <a asp-area="CarOwner" asp-controller="Cars" asp-action="Create" class="btn btn-primary"> Add Car</a>
            </div>
            <div class="col-md-4">
                <select id="sortOrderSelect" class="custom-select w-75 custom-select-lg d-block float-right">
                    <option value="Newest to Lastest">Newest to Lastest</option>
                    <option value="Lastest to Newest">Lastest to Newest</option>
                    <option value="Order By Price">Order By Price</option>
                </select>
            </div>
        </div>
        <div id="modelListContainer">
            <partial name="_CarsListPartial" model="Model" />
        </div>

        <div class="row mt-5">
            <div class="col text-center">
                <div class="block-27" id="paginationContainer" data-total-pages="@ViewBag.TotalPages">
                    <ul>
                        <li><a id="previous-page">&lt;</a></li>
                        <li class="active"><span>1</span></li>
                        <li><a id="next-page">&gt;</a></li>
                    </ul>
                </div>
            </div>
        </div>
    </div>
</section>

<script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
<script>

    window.onload = function () {
        var carElements = document.querySelectorAll("[id^='carStatus']");
        carElements.forEach(function (carElement) {
            var carStatus = carElement.textContent.trim();

            switch (carStatus) {
                case "Available":
                    carElement.style.color = "green";
                    break;
                case "Booked":
                    carElement.style.color = "blue";
                    break;
                case "Stopped":
                    carElement.style.color = "red";
                    break;
                default:
                    carElement.style.color = "black";
            }
        });
    };

    $(document).ready(function () {
        // Function to update cars based on sort order and page number
        function updateCars(sortOrder, pageNumber) {
            $.ajax({
                url: '/CarOwner/Cars/SortAndPaginateCars',
                type: 'GET',
                data: { sortOrder: sortOrder, pageNumber: pageNumber },

                success: function (result) {
                    $('#modelListContainer').empty();
                    $('#modelListContainer').html(result);
                    console.log(result);

                    updatePagination(pageNumber);
                }
            });
        }

        // display sorted car default each time reloading page

    @* var initialSortOrder = $('#sortOrderSelect').val();

            // Update cars with initial sort order (page number is 1)
            updateCars(initialSortOrder, 1);*@

            // Function to update pagination links
            function updatePagination(currentPage) {
                var totalPages = parseInt($('#paginationContainer').attr('data-total-pages'));
                var paginationContainer = $('#paginationContainer');
                paginationContainer.empty();

                if (currentPage > 1) {
                    paginationContainer.prepend('<a id="previous-page">&lt;</a>');
                }

                for (var i = 1; i <= totalPages; i++) {
                    if (i === currentPage) {
                        paginationContainer.append('<span class="active">' + i + '</span>');
                    } else {
                        paginationContainer.append('<a data-page="' + i + '">' + i + '</a>');
                    }
                }

                if (currentPage < totalPages) {
                    paginationContainer.append('<a id="next-page">&gt;</a>');
                }
            }

        // Event handler for sort order change
        $(document).on('change', '#sortOrderSelect', function () {
            var sortOrder = $(this).val();
            var pageNumber = 1;

            updateCars(sortOrder, pageNumber);
        });

        // Event handler for pagination link click
        $(document).on('click', '#paginationContainer a', function () {
            var sortOrder = $('#sortOrderSelect').val();
            var pageNumber = $(this).data('page');

            updateCars(sortOrder, pageNumber);
        });

        // Event handler for previous page button click
        $(document).on('click', '#previous-page', function () {
            var sortOrder = $('#sortOrderSelect').val();
            var currentPage = parseInt($('#paginationContainer .active').text());
            var pageNumber = currentPage - 1;

            updateCars(sortOrder, pageNumber);
        });

        // Event handler for next page button click
        $(document).on('click', '#next-page', function () {
            var sortOrder = $('#sortOrderSelect').val();
            var currentPage = parseInt($('#paginationContainer .active').text());
            var pageNumber = currentPage + 1;

            updateCars(sortOrder, pageNumber);
        });
    });
</script>
@section Css {
    <style>
        .checked {
            color: orange;
        }
    </style>
}

src/CarRental/CarRental.Web/Areas/CarOwner/Views/Cars/_CarsListPartial.cshtml
@model IEnumerable<CarRental.Core.Models.Car>

@{
    var i = 0;
}
@if (Model == null)
{
    <h3 class="justify-content-center align-content-center">You have no car in here!</h3>
}
else
{
    @foreach (var item in Model)
    {
        <div class="car-wrap car-wrapper rounded ftco-animate mt-4 mb-4">
            <div class="row blog_1 mb-5">
                <div class="col-md-5">
                    <div class="car-wrap rounded ftco-animate m-2">
                        <div id="carouselExampleIndicators_@i" class="carousel slide" data-ride="carousel">
                            <ol class="carousel-indicators">
                                <li data-target="#carouselExampleIndicators_@i" data-slide-to="0" class="active"></li>
                                <li data-target="#carouselExampleIndicators_@i" data-slide-to="1"></li>
                                <li data-target="#carouselExampleIndicators_@i" data-slide-to="2"></li>
                                <li data-target="#carouselExampleIndicators_@i" data-slide-to="3"></li>
                            </ol>
                            <div class="carousel-inner">
                                <div class="carousel-item active">
                                    <img class="d-block w-100 rounded" src="@Url.Content(item.CarImage.FrontImg)" alt="First slide">
                                </div>
                                <div class="carousel-item">
                                    <img class="d-block w-100 rounded" src="@Url.Content(item.CarImage.BackImg)" alt="Second slide">
                                </div>
                                <div class="carousel-item">
                                    <img class="d-block w-100 rounded" src="@Url.Content(item.CarImage.LeftImg)" alt="Third slide">
                                </div>
                                <div class="carousel-item">
                                    <img class="d-block w-100 rounded" src="@Url.Content(item.CarImage.RightImg)" alt="Fourth slide">
                                </div>
                            </div>
                            <a class="carousel-control-prev" href="#carouselExampleIndicators_@i" role="button"
                               data-slide="prev">
                                <span class="carousel-control-prev-icon" aria-hidden="true"></span>
                                <span class="sr-only">Previous</span>
                            </a>
                            <a class="carousel-control-next" href="#carouselExampleIndicators_@i" role="button"
                               data-slide="next">
                                <span class="carousel-control-next-icon" aria-hidden="true"></span>
                                <span class="sr-only">Next</span>
                            </a>

                        </div>
                    </div>
                </div>
                <div class="col-md-4" style="color: black;">
                    <div class="card-title col-md col-sm mt-2">
                        <h2 class="font-weight-bold">@item.CarName</h2>
                    </div>
                    <div class="model_pg1i clearfix">
                        <div class="model_m clearfix border-top-0">
                            <div class="model_pg1i2 row">
                                <div class="col-md-3 col-sm-3">
                                    <div class="model_pg1i2r">
                                        <span>Ratings:</span>

                                    </div>
                                </div>
                                <div class="col-md-9 col-sm-9">
                                    <div class="model_pg1i2l">
                                        <span class="star">
                                            @if (double.IsNaN(ViewBag.AvgRate) || ViewBag.AvgRate < 0.5)
                                            {
                                                <span class="fa fa-star"></span>
                                                <span class="fa fa-star "></span>
                                                <span class="fa fa-star "></span>
                                                <span class="fa fa-star"></span>
                                                <span class="fa fa-star"></span>
                                            }
                                            else if (ViewBag.AvgRate >= 0.5 && ViewBag.AvgRate < 1.5)
                                            {
                                                <span class="fa fa-star checked"></span>
                                                <span class="fa fa-star "></span>
                                                <span class="fa fa-star "></span>
                                                <span class="fa fa-star "></span>
                                                <span class="fa fa-star "></span>
                                            }
                                            else if (ViewBag.AvgRate >= 1.5 && ViewBag.AvgRate < 2.5)
                                            {
                                                <span class="fa fa-star checked"></span>
                                                <span class="fa fa-star checked"></span>
                                                <span class="fa fa-star "></span>
                                                <span class="fa fa-star "></span>
                                                <span class="fa fa-star "></span>
                                            }
                                            else if (ViewBag.AvgRate >= 2.5 && ViewBag.AvgRate < 3.5)
                                            {
                                                <span class="fa fa-star checked"></span>
                                                <span class="fa fa-star checked"></span>
                                                <span class="fa fa-star checked"></span>
                                                <span class="fa fa-star checked"></span>
                                                <span class="fa fa-star "></span>
                                            }
                                            else if (ViewBag.AvgRate >= 3.5 && ViewBag.AvgRate < 4.5)
                                            {
                                                <span class="fa fa-star checked"></span>
                                                <span class="fa fa-star checked"></span>
                                                <span class="fa fa-star checked"></span>
                                                <span class="fa fa-star checked"></span>
                                                <span class="fa fa-star "></span>
                                            }
                                            else if (ViewBag.AvgRate >= 4.5)
                                            {
                                                <span class="fa fa-star checked"></span>
                                                <span class="fa fa-star checked"></span>
                                                <span class="fa fa-star checked"></span>
                                                <span class="fa fa-star checked"></span>
                                                <span class="fa fa-star checked"></span>
                                            }
                                        </span>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="model_m clearfix border-top-0 mt-2">
                            <div class="model_pg1i2 row">
                                <div class="col-md-4 col-sm-3">
                                    <div class="model_pg1i2r">
                                        <span>
                                            No. of rides:

                                        </span>
                                    </div>
                                </div>
                                <div class="col-md-8 col-sm-9">
                                    <div class="model_pg1i2l">
                                        <span class="price">0</span>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="model_m clearfix border-top-0 mt-2">
                            <div class="model_pg1i2 row">
                                <div class="col-md-3 col-sm-3">
                                    <div class="model_pg1i2r">
                                        <label class="mb-0 fw-bolder">Price:</label>
                                    </div>
                                </div>
                                <div class="col-md-9 col-sm-9">
                                    <div class="model_pg1i2l">
                                        <span class="price"> @string.Format("{0:N0} VND", @item.BasePrice)/day</span>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="model_m clearfix border-top-0 mt-2">
                            <div class="model_pg1i2 row">
                                <div class="col-md-3 col-sm-3">
                                    <div class="model_pg1i2r">
                                        <label class="mb-0 fw-bolder">Locations:</label>
                                    </div>
                                </div>

                                <div class="col-md-9 col-sm-9">
                                    <div class="model_pg1i2l">
                                        <span class="price">
                                            @if (!string.IsNullOrEmpty(item.SpecificAddress))
                                            {
                                                @item.SpecificAddress

                                                <span>, </span>
                                            }
                                            @item.Address.Ward,
                                            @item.Address.District,
                                            @item.Address.City
                                        </span>
                                    </div>
                                </div>
                            </div>
                        </div>

                        <div class="model_m clearfix border-top-0 mt-2 mb-2">
                            <div class="model_pg1i2 row">
                                <div class="col-md-3 col-sm-3">
                                    <div class="model_pg1i2r">
                                        <label class="mb-0 fw-bolder">Status:</label>
                                    </div>
                                </div>

                                <div class="col-md-9 col-sm-9">
                                    <div class="model_pg1i2l">
                                        <span class="price" id="carStatus_@i" onchange="changeColorCarStatus(@i)">
                                            @item.CarStatus
                                        </span>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="col-md-3">
                    <p class="mt-4 align-items-end">
                        <a href="@Url.Action("EditCar", "Cars",
                            new { carId = item.CarId })" class="btn btn-primary d-block w-75 pt-2 mb-2">
                            View Details
                        </a>
                        @{
                            i++;
                        }
                    </p>
                </div>
            </div>
        </div>

    }
}